#include <ntddk.h>
#include <windef.h>
#include "LDasm.h"

#define NT_DEVICE_NAME                L"\\Device\\ProtMBR"
#define DOS_DEVICE_NAME               L"\\DosDevices\\ProtMBR"

#define IOCTL_Hook				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x1, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_UnHook			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x2, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef NTSTATUS (*NTCREATEFILE)
(
 OUT PHANDLE FileHandle,
 IN ACCESS_MASK DesiredAccess,
 IN POBJECT_ATTRIBUTES ObjectAttributes,
 OUT PIO_STATUS_BLOCK IoStatusBlock,
 IN PLARGE_INTEGER AllocationSize OPTIONAL,
 IN ULONG FileAttributes,
 IN ULONG ShareAccess,
 IN ULONG CreateDisposition,
 IN ULONG CreateOptions,
 IN PVOID EaBuffer OPTIONAL,
 IN ULONG EaLength
);

NTCREATEFILE			NtCreateFile=NULL,Old_NtCreateFile=NULL;
KIRQL f_oldirql;
KSPIN_LOCK f_spinlock;

BOOLEAN SpyFindSubString(PUNICODE_STRING String,PUNICODE_STRING SubString)
{
	ULONG Index;
	if(RtlEqualUnicodeString(String,SubString,TRUE))
	{
		return TRUE;
	}
	for(Index=0;Index+(SubString->Length/sizeof(WCHAR))<=(String->Length/sizeof(WCHAR));Index++)
	{
		if(_wcsnicmp(&String->Buffer[Index],SubString->Buffer,(SubString->Length/sizeof(WCHAR)))==0)
		{
			return TRUE;
		}
	}
	return FALSE;
}

NTSTATUS fake_NtCreateFile(OUT PHANDLE FileHandle,IN ACCESS_MASK DesiredAccess,IN POBJECT_ATTRIBUTES ObjectAttributes,OUT PIO_STATUS_BLOCK IoStatusBlock,IN PLARGE_INTEGER AllocationSize OPTIONAL,IN ULONG FileAttributes,IN ULONG ShareAccess,IN ULONG CreateDisposition,IN ULONG CreateOptions,IN PVOID EaBuffer OPTIONAL,IN ULONG EaLength)
{
	UNICODE_STRING uniFileName;
	NTSTATUS st;
	if(MmIsAddressValid(ObjectAttributes)==TRUE)
	{
		if(MmIsAddressValid(ObjectAttributes->ObjectName)==TRUE)
		{
			if(MmIsAddressValid(ObjectAttributes->ObjectName->Buffer)==TRUE)
			{
				RtlInitUnicodeString(&uniFileName,L"PhysicalDrive");
				if(SpyFindSubString(ObjectAttributes->ObjectName,&uniFileName)==TRUE)
				{
					st=STATUS_ACCESS_DENIED;
				}
				else
				{
					st=Old_NtCreateFile(FileHandle,DesiredAccess,ObjectAttributes,IoStatusBlock,AllocationSize,FileAttributes,ShareAccess,CreateDisposition,CreateOptions,EaBuffer,EaLength);
				}
			}
			else
			{
				st=STATUS_INVALID_PARAMETER;
			}
		}
		else
		{
			st=STATUS_INVALID_PARAMETER;
		}
	}
	else
	{
		st=STATUS_INVALID_PARAMETER;
	}
	return st;
}

void HookNtCreateFile()
{
	PMDL pMdl;
	ULONG PatchSize;
	BYTE g_HookCode[5]={0xE9,0,0,0,0};//ת
	BYTE Jmp_Orig_Code[7]={0xEA,0,0,0,0,0x08,0x00 }; //Եַת
	UNICODE_STRING uniFuncName;
	RtlInitUnicodeString(&uniFuncName,L"NtCreateFile");
	NtCreateFile=MmGetSystemRoutineAddress(&uniFuncName);
	PatchSize=GetPatchSize(NtCreateFile,5);//ҪPatchֽ 
	//Proxy_Func
	Old_NtCreateFile=ExAllocatePool(NonPagedPool,20);
	memset(Old_NtCreateFile,0x90,20);
	RtlCopyMemory((PBYTE)Old_NtCreateFile,(PBYTE)NtCreateFile,PatchSize);//ʵԭͷ
	*((PULONG)(Jmp_Orig_Code+1))=(ULONG)((PBYTE)NtCreateFile+PatchSize );//ԭ+N ַ
	RtlCopyMemory((PBYTE)Old_NtCreateFile+PatchSize,Jmp_Orig_Code,7);//Եַת
	*((ULONG*)(g_HookCode+1))=(ULONG)fake_NtCreateFile-(ULONG)NtCreateFile-5;//JMP ַ
	pMdl=IoAllocateMdl(NtCreateFile,5,FALSE,FALSE,NULL);
	if(pMdl)
	{
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		f_oldirql=KeRaiseIrqlToDpcLevel();
		KeInitializeSpinLock(&f_spinlock);
		KeAcquireSpinLockAtDpcLevel(&f_spinlock);
		_asm
		{
			cli              
			mov eax, cr0   
			and eax, not 10000h
			mov cr0, eax     
		}
		RtlCopyMemory(NtCreateFile, g_HookCode, 5);
		_asm 
		{
			mov eax, cr0    
			or  eax, 10000h            
			mov cr0, eax              
			sti                  
		}
		KeReleaseSpinLockFromDpcLevel(&f_spinlock);
		KeLowerIrql(f_oldirql);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
}

void UnhookNtCreateFile()
{
	PMDL pMdl;
	pMdl=IoAllocateMdl(NtCreateFile,5,FALSE,FALSE,NULL);
	if(pMdl)
	{
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		f_oldirql=KeRaiseIrqlToDpcLevel();
		KeInitializeSpinLock(&f_spinlock);
		KeAcquireSpinLockAtDpcLevel(&f_spinlock);
		_asm
		{
			cli              
			mov eax, cr0   
			and eax, not 10000h
			mov cr0, eax     
		}
		RtlCopyMemory(NtCreateFile,Old_NtCreateFile,5);
		_asm 
		{
			mov eax, cr0    
			or  eax, 10000h            
			mov cr0, eax              
			sti                  
		}
		KeReleaseSpinLockFromDpcLevel(&f_spinlock);
		KeLowerIrql(f_oldirql);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
	ExFreePool(Old_NtCreateFile);
}