#include <ntddk.h>
#include <windef.h>

#define NT_DEVICE_NAME                L"\\Device\\ProtMBR"
#define DOS_DEVICE_NAME               L"\\DosDevices\\ProtMBR"

#define IOCTL_Hook				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x1, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_UnHook			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x2, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef NTSTATUS (*IRP_MJ_SERIES)
(
 IN PDEVICE_OBJECT DeviceObject,
 IN PIRP Irp
);

IRP_MJ_SERIES		IrpMjRead=NULL,IrpMjWrite=NULL;
PDRIVER_OBJECT		DiskDrvObj=NULL;
BOOLEAN				IsHooked;
extern POBJECT_TYPE* IoDriverObjectType; 

NTSTATUS NTAPI ObReferenceObjectByName(IN PUNICODE_STRING ObjectName,IN ULONG Attributes,IN PACCESS_STATE PassedAccessState OPTIONAL,IN ACCESS_MASK DesiredAccess OPTIONAL,IN POBJECT_TYPE ObjectType,IN KPROCESSOR_MODE AccessMode,IN OUT PVOID ParseContext OPTIONAL,OUT PVOID *Object );

NTSTATUS fake_IrpMjWrite(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp)
{
	NTSTATUS status = STATUS_SUCCESS;
	IO_STACK_LOCATION  *irpsp= IoGetCurrentIrpStackLocation(Irp);
	LARGE_INTEGER WriteOffsetInBytes= irpsp->Parameters.Write.ByteOffset;
	ULONG writeLength = irpsp->Parameters.Write.Length;
	LARGE_INTEGER Sectionpos={0};
	ULONG SectorRange;
	BOOLEAN IsDeniedAccess = FALSE; 
	do 
	{
		Sectionpos.HighPart = 0;
		Sectionpos.LowPart = 0x200;
		SectorRange= WriteOffsetInBytes.QuadPart/Sectionpos.QuadPart;
		if(SectorRange==0 && DeviceObject->DeviceType==FILE_DEVICE_DISK)
		{
			IsDeniedAccess =TRUE;
			break;
		}
	}while(0);
	if (IsDeniedAccess)
	{
		Irp->IoStatus.Information=writeLength;
		Irp->IoStatus.Status=STATUS_ACCESS_DENIED;
		IoCompleteRequest(Irp,IO_NO_INCREMENT); 
		status=STATUS_ACCESS_DENIED;
	}
	else
	{
		status=IrpMjWrite(DeviceObject,Irp);
	}
	return status;
}

NTSTATUS fake_IrpMjRead(IN PDEVICE_OBJECT DeviceObject,IN PIRP Irp)
{
	NTSTATUS status = STATUS_SUCCESS;
	IO_STACK_LOCATION  *irpsp= IoGetCurrentIrpStackLocation(Irp);
	LARGE_INTEGER ReadOffsetInBytes= irpsp->Parameters.Read.ByteOffset;
	ULONG readLength = irpsp->Parameters.Write.Length;
	LARGE_INTEGER Sectionpos={0};
	ULONG SectorRange;
	BOOLEAN IsDeniedAccess = FALSE; 
	do 
	{
		Sectionpos.HighPart = 0;
		Sectionpos.LowPart = 0x200;
		SectorRange= ReadOffsetInBytes.QuadPart/Sectionpos.QuadPart;
		if(SectorRange==0 && DeviceObject->DeviceType==FILE_DEVICE_DISK)
		{
			IsDeniedAccess =TRUE;
			break;
		}
	}while(0);
	if (IsDeniedAccess)
	{
		Irp->IoStatus.Information=readLength;
		Irp->IoStatus.Status=STATUS_ACCESS_DENIED;
		IoCompleteRequest(Irp,IO_NO_INCREMENT); 
		status=STATUS_ACCESS_DENIED;
	}
	else
	{
		status=IrpMjWrite(DeviceObject,Irp);
	}
	return status;
}

void StartHook()
{
	NTSTATUS st;
	UNICODE_STRING uniDiskName;
	RtlInitUnicodeString(&uniDiskName,L"\\Driver\\Disk");
	st=ObReferenceObjectByName(&uniDiskName,OBJ_CASE_INSENSITIVE,0,0,*IoDriverObjectType,KernelMode,0,&DiskDrvObj);
	if(NT_SUCCESS(st))
	{
		IrpMjRead=(IRP_MJ_SERIES)InterlockedExchangePointer(&DiskDrvObj->MajorFunction[IRP_MJ_READ],fake_IrpMjRead);
		IrpMjWrite=(IRP_MJ_SERIES)InterlockedExchangePointer(&DiskDrvObj->MajorFunction[IRP_MJ_WRITE],fake_IrpMjWrite);
		IsHooked=TRUE;
	}
}

void StopHook()
{
	InterlockedExchangePointer(&DiskDrvObj->MajorFunction[IRP_MJ_READ],IrpMjRead);
	InterlockedExchangePointer(&DiskDrvObj->MajorFunction[IRP_MJ_WRITE],IrpMjWrite);
	ObDereferenceObject(DiskDrvObj);
   IsHooked=FALSE;
}