#include <ntddk.h>
#include <windef.h>
#include "LDasm.h"

#define NT_DEVICE_NAME                L"\\Device\\ProtMBR"
#define DOS_DEVICE_NAME               L"\\DosDevices\\ProtMBR"

#define IOCTL_Hook				CTL_CODE(FILE_DEVICE_UNKNOWN, 0x1, METHOD_BUFFERED, FILE_ANY_ACCESS)
#define IOCTL_UnHook			CTL_CODE(FILE_DEVICE_UNKNOWN, 0x2, METHOD_BUFFERED, FILE_ANY_ACCESS)

typedef NTSTATUS (*IOPCREATEFILE)
(
 OUT PHANDLE FileHandle,
 IN ACCESS_MASK DesiredAccess,
 IN POBJECT_ATTRIBUTES ObjectAttributes,
 OUT PIO_STATUS_BLOCK IoStatusBlock,
 IN PLARGE_INTEGER AllocationSize OPTIONAL,
 IN ULONG FileAttributes,
 IN ULONG ShareAccess,
 IN ULONG Disposition,
 IN ULONG CreateOptions,
 IN PVOID EaBuffer OPTIONAL,
 IN ULONG EaLength,
 IN CREATE_FILE_TYPE CreateFileType,
 IN PVOID InternalParameters OPTIONAL,
 IN ULONG Options,
 IN ULONG InternalFlags,
 IN PVOID DeviceObject
);

IOPCREATEFILE			IopCreateFile=NULL,Old_IopCreateFile=NULL;
KIRQL f_oldirql;
KSPIN_LOCK f_spinlock;

BOOLEAN SpyFindSubString(PUNICODE_STRING String,PUNICODE_STRING SubString)
{
	ULONG Index;
	if(RtlEqualUnicodeString(String,SubString,TRUE))
	{
		return TRUE;
	}
	for(Index=0;Index+(SubString->Length/sizeof(WCHAR))<=(String->Length/sizeof(WCHAR));Index++)
	{
		if(_wcsnicmp(&String->Buffer[Index],SubString->Buffer,(SubString->Length/sizeof(WCHAR)))==0)
		{
			return TRUE;
		}
	}
	return FALSE;
}

NTSTATUS fake_IopCreateFile(OUT PHANDLE FileHandle,IN ACCESS_MASK DesiredAccess,IN POBJECT_ATTRIBUTES ObjectAttributes,OUT PIO_STATUS_BLOCK IoStatusBlock,IN PLARGE_INTEGER AllocationSize OPTIONAL,IN ULONG FileAttributes,IN ULONG ShareAccess,IN ULONG Disposition,IN ULONG CreateOptions,IN PVOID EaBuffer OPTIONAL,IN ULONG EaLength,IN CREATE_FILE_TYPE CreateFileType,IN PVOID InternalParameters OPTIONAL,IN ULONG Options,IN ULONG InternalFlags,IN PVOID DeviceObject)
{
	UNICODE_STRING uniFileName;
	NTSTATUS st;
	if(MmIsAddressValid(ObjectAttributes)==TRUE)
	{
		if(MmIsAddressValid(ObjectAttributes->ObjectName)==TRUE)
		{
			if(MmIsAddressValid(ObjectAttributes->ObjectName->Buffer)==TRUE)
			{
				RtlInitUnicodeString(&uniFileName,L"PhysicalDrive");
				if(SpyFindSubString(ObjectAttributes->ObjectName,&uniFileName)==TRUE)
				{
					st=STATUS_ACCESS_DENIED;
				}
				else
				{
					st=Old_IopCreateFile(FileHandle,DesiredAccess,ObjectAttributes,IoStatusBlock,AllocationSize,FileAttributes,ShareAccess,Disposition,CreateOptions,EaBuffer,EaLength,CreateFileType,InternalParameters,Options,InternalFlags,DeviceObject);
				}
			}
			else
			{
				st=STATUS_INVALID_PARAMETER;
			}
		}
		else
		{
			st=STATUS_INVALID_PARAMETER;
		}
	}
	else
	{
		st=STATUS_INVALID_PARAMETER;
	}
	return st;
}

NTSTATUS ReadKernelMemory(PVOID Address, ULONG Size, PVOID OutBuffer)
{
	NTSTATUS st = STATUS_UNSUCCESSFUL;
	PMDL  pMdl = 0;
	PVOID pAddress = 0;
	if (!Address) return st;
	pMdl = IoAllocateMdl(Address, Size, FALSE, FALSE, 0);
    if (pMdl)
    {
        MmBuildMdlForNonPagedPool(pMdl);
        pAddress = MmGetSystemAddressForMdlSafe(pMdl, NormalPagePriority);
        if (pAddress)
        {
			__try
			{
				RtlCopyMemory(OutBuffer, pAddress, Size);
				st = STATUS_SUCCESS;
			}
			__except(EXCEPTION_EXECUTE_HANDLER)
			{                    
			}
        }            
        IoFreeMdl(pMdl);
    }
    return st;
}

ULONG FindIopCreateFile()
{
	ULONG SrcFuncAddr=0, i=0, DWordVal=0, OffsetAddr=0;
	UNICODE_STRING uniFuncName;
	RtlInitUnicodeString(&uniFuncName,L"IoCreateFile");
	SrcFuncAddr = (ULONG)MmGetSystemRoutineAddress(&uniFuncName);
	for(i=0;i<1024;i++)
	{
		if( MmIsAddressValid((PVOID)(SrcFuncAddr+i)) )
		{
			ReadKernelMemory((PVOID)(SrcFuncAddr+i),4,&DWordVal);
			if(DWordVal==0xE80875FF)	//char code of xp/win7
			{
				ReadKernelMemory((PVOID)(SrcFuncAddr+i+4),4,&OffsetAddr);
				return (OffsetAddr + 5 + SrcFuncAddr+i+3);
			}
		}
	}
	return 0;
}

void HookIopCreateFile()
{
	PMDL pMdl;
	ULONG PatchSize;
	BYTE g_HookCode[5]={0xE9,0,0,0,0};//ת
	BYTE Jmp_Orig_Code[7]={0xEA,0,0,0,0,0x08,0x00 }; //Եַת
	IopCreateFile=(PVOID)FindIopCreateFile();
	PatchSize=GetPatchSize(IopCreateFile,5);//ҪPatchֽ 
	//Proxy_Func
	Old_IopCreateFile=ExAllocatePool(NonPagedPool,20);
	memset(Old_IopCreateFile,0x90,20);
	RtlCopyMemory((PBYTE)Old_IopCreateFile,(PBYTE)IopCreateFile,PatchSize);//ʵԭͷ
	*((PULONG)(Jmp_Orig_Code+1))=(ULONG)((PBYTE)IopCreateFile+PatchSize );//ԭ+N ַ
	RtlCopyMemory((PBYTE)Old_IopCreateFile+PatchSize,Jmp_Orig_Code,7);//Եַת
	*((ULONG*)(g_HookCode+1))=(ULONG)fake_IopCreateFile-(ULONG)IopCreateFile-5;//JMP ַ
	pMdl=IoAllocateMdl(IopCreateFile,5,FALSE,FALSE,NULL);
	if(pMdl)
	{
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		f_oldirql=KeRaiseIrqlToDpcLevel();
		KeInitializeSpinLock(&f_spinlock);
		KeAcquireSpinLockAtDpcLevel(&f_spinlock);
		_asm
		{
			cli              
			mov eax, cr0   
			and eax, not 10000h
			mov cr0, eax     
		}
		RtlCopyMemory(IopCreateFile, g_HookCode, 5);
		_asm 
		{
			mov eax, cr0    
			or  eax, 10000h            
			mov cr0, eax              
			sti                  
		}
		KeReleaseSpinLockFromDpcLevel(&f_spinlock);
		KeLowerIrql(f_oldirql);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
}

void UnhookIopCreateFile()
{
	PMDL pMdl;
	pMdl=IoAllocateMdl(IopCreateFile,5,FALSE,FALSE,NULL);
	if(pMdl)
	{
		__try
		{
			MmProbeAndLockPages(pMdl,KernelMode,IoWriteAccess);
		}
		__except(EXCEPTION_EXECUTE_HANDLER)
		{
			IoFreeMdl(pMdl);
		}
		f_oldirql=KeRaiseIrqlToDpcLevel();
		KeInitializeSpinLock(&f_spinlock);
		KeAcquireSpinLockAtDpcLevel(&f_spinlock);
		_asm
		{
			cli              
			mov eax, cr0   
			and eax, not 10000h
			mov cr0, eax     
		}
		RtlCopyMemory(IopCreateFile,Old_IopCreateFile,5);
		_asm 
		{
			mov eax, cr0    
			or  eax, 10000h            
			mov cr0, eax              
			sti                  
		}
		KeReleaseSpinLockFromDpcLevel(&f_spinlock);
		KeLowerIrql(f_oldirql);
		MmUnlockPages(pMdl);
		IoFreeMdl(pMdl);
	}
	ExFreePool(Old_IopCreateFile);
}